// THIS FILE IS AUTO-GENERATED FROM server_connection.js
// DO NOT EDIT.
// +build with_embed

package ui

import "time"

import "perkeep.org/pkg/fileembed"

func init() {
	Files.Add("server_connection.js", 24424, time.Unix(0, 1605118498720856000), fileembed.String(fileembed.JoinStrings("/*\n"+
		"Copyright 2013 The Perkeep Authors\n"+
		"\n"+
		"Licensed under the Apache License, Version 2.0 (the \"License\");\n"+
		"you may not use this file except in compliance with the License.\n"+
		"You may obtain a copy of the License at\n"+
		"\n"+
		"	http://www.apache.org/licenses/LICENSE-2.0\n"+
		"\n"+
		"Unless required by applicable law or agreed to in writing, software\n"+
		"distributed under the License is distributed on an \"AS IS\" BASIS,\n"+
		"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"+
		"See the License for the specific language governing permissions and\n"+
		"limitations under the License.\n"+
		"*/\n"+
		"\n"+
		"goog.provide('cam.ServerConnection');\n"+
		"\n"+
		"goog.require('goog.string');\n"+
		"goog.require('goog.net.XhrIo');\n"+
		"goog.require('goog.Uri'); // because goog.net.XhrIo forgot to include it.\n"+
		"goog.require('goog.debug.ErrorHandler'); // because goog.net.Xhrio forgot to incl"+
		"ude it.\n"+
		"goog.require('goog.uri.utils');\n"+
		"\n"+
		"goog.require('cam.blob');\n"+
		"goog.require('cam.ServerType');\n"+
		"goog.require('cam.WorkerMessageRouter');\n"+
		"\n"+
		"// TODO(mpl): directly get it from the auth pkg if we use gopherjs.\n"+
		"var OMIT_AUTH_TOKEN = \"OmitAuthToken\";\n"+
		"\n"+
		"// @fileoverview Connection to the blob server and API for the RPCs it provides. "+
		"All blob index UI code should use this connection to contact the server.\n"+
		"// @param {cam.ServerType.DiscoveryDocument} config Discovery document for the cu"+
		"rrent server.\n"+
		"// @param {Function=} opt_sendXhr Function for sending XHRs for testing.\n"+
		"// @constructor\n"+
		"cam.ServerConnection = function(config, opt_sendXhr) {\n"+
		"	this.config_ = config;\n"+
		"	this.sendXhr_ = opt_sendXhr || goog.net.XhrIo.send;\n"+
		"	this.worker_ = null;\n"+
		"};\n"+
		"\n"+
		"cam.ServerConnection.DESCRIBE_REQUEST = {\n"+
		"	// TODO(aa): This is not perfect. The describe request will return some data we "+
		"don't care about:\n"+
		"	// - Properties we don't use\n"+
		"	// See: https://perkeep.org/issue/319\n"+
		"\n",
		"	depth: 1,\n"+
			"	rules: [\n"+
			"		{\n"+
			"			attrs: ['camliContent', 'camliContentImage']\n"+
			"		},\n"+
			"		{\n"+
			"			ifCamliNodeType: 'foursquare.com:checkin',\n"+
			"			attrs: ['foursquareVenuePermanode']\n"+
			"		},\n"+
			"		{\n"+
			"			ifCamliNodeType: 'foursquare.com:venue',\n"+
			"			attrs: ['camliPath:photos'],\n"+
			"			rules: [\n"+
			"				{ attrs: ['camliPath:*'] }\n"+
			"			]\n"+
			"		}\n"+
			"	]\n"+
			"};\n"+
			"\n"+
			"cam.ServerConnection.prototype.getPermanodeWithContent = function(contentRef, suc"+
			"cess) {\n"+
			"	var query = {\n"+
			"		permanode: {\n"+
			"			attr: \"camliContent\",\n"+
			"			value: contentRef,\n"+
			"		},\n"+
			"	};\n"+
			"	var callback = function(result) {\n"+
			"		if (!result || !result.blobs || result.blobs.length == 0) {\n"+
			"			success();\n"+
			"			return;\n"+
			"		}\n"+
			"		success(result.blobs[0].blob);\n"+
			"	}\n"+
			"	this.search(query, null, callback);\n"+
			"};\n"+
			"\n"+
			"// If child is a camliMember of parent success is called with 'true', otherrwise "+
			"'false'\n"+
			"// @param {string} blobref of the child\n"+
			"// @param {string} blobref of the parent\n"+
			"// @param {Function} success callback with data.\n"+
			"cam.ServerConnection.prototype.isCamliMember = function(child, parent, success) {\n"+
			"	var query = {\n"+
			"		logical: {\n"+
			"			a: {\n"+
			"				permanode: {\n"+
			"					attr: \"camliMember\",\n"+
			"					ValueInSet: {\n"+
			"						blobRefPrefix: child,\n",
		"					}\n"+
			"				}\n"+
			"			},\n"+
			"			op: \"and\",\n"+
			"			b: {\n"+
			"				blobRefPrefix: parent,\n"+
			"			}\n"+
			"		},\n"+
			"	};\n"+
			"	var callback = function(result) {\n"+
			"		if (!result || !result.blobs || result.blobs.length == 0) {\n"+
			"			success(false);\n"+
			"			return;\n"+
			"		}\n"+
			"		success(true);\n"+
			"	}\n"+
			"	this.search(query, null, callback);\n"+
			"};\n"+
			"\n"+
			"cam.ServerConnection.prototype.getWorker_ = function() {\n"+
			"	if (!this.worker_) {\n"+
			"		var r = new Date().getTime(); // For cachebusting the worker. Sigh. We need con"+
			"tent stamping.\n"+
			"		this.worker_ = new cam.WorkerMessageRouter(new Worker('hash_worker.js?r=' + r))"+
			";\n"+
			"	}\n"+
			"	return this.worker_;\n"+
			"};\n"+
			"\n"+
			"cam.ServerConnection.prototype.getConfig = function() {\n"+
			"	return this.config_;\n"+
			"};\n"+
			"\n"+
			"// @param {string} blobref blobref whose contents we want.\n"+
			"// @param {Function} success callback with data.\n"+
			"// @param {?Function} opt_fail optional failure calback\n"+
			"cam.ServerConnection.prototype.getBlobContents = function(blobref, success, opt_f"+
			"ail) {\n"+
			"	var path = goog.uri.utils.appendPath(\n"+
			"		this.config_.blobRoot, 'camli/' + blobref\n"+
			"	);\n"+
			"	this.sendXhr_(path,\n"+
			"		goog.bind(this.handleXhrResponseText_, this,\n"+
			"			{success: success, fail: opt_fail}\n"+
			"		)\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {goog.events.Event} e Event that triggered this\n"+
			"cam.ServerConnection.prototype.handleXhrResponseJson_ = function(callbacks, e) {\n",
		"	var success = callbacks.success\n"+
			"	var fail = callbacks.fail\n"+
			"	var xhr = e.target;\n"+
			"	var error = !xhr.isSuccess();\n"+
			"	var result = null;\n"+
			"\n"+
			"	try {\n"+
			"		result = xhr.getResponseJson();\n"+
			"	} catch(err) {\n"+
			"		result = \"Response was not valid JSON: \" + xhr.getResponseText();\n"+
			"	}\n"+
			"\n"+
			"	if (error) {\n"+
			"		if (fail) {\n"+
			"			fail(result);\n"+
			"		} else {\n"+
			"			console.log('Failed XHR (JSON) in ServerConnection: ' + result.error || result"+
			");\n"+
			"		}\n"+
			"	} else {\n"+
			"		success(result);\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"// @param {Function} success callback with data.\n"+
			"// @param {?Function} opt_fail optional failure calback\n"+
			"cam.ServerConnection.prototype.discoSignRoot = function(success, opt_fail) {\n"+
			"	var path = goog.uri.utils.appendPath(this.config_.jsonSignRoot, '/camli/sig/disc"+
			"overy');\n"+
			"	this.sendXhr_(path, goog.bind(this.handleXhrResponseJson_, this, {success: succe"+
			"ss, fail: opt_fail}));\n"+
			"};\n"+
			"\n"+
			"// @param {function(cam.ServerType.StatusResponse)} success.\n"+
			"cam.ServerConnection.prototype.serverStatus = function(success) {\n"+
			"	var path = goog.uri.utils.appendPath(this.config_.statusRoot, 'status.json');\n"+
			"\n"+
			"	this.sendXhr_(path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this, {success: success, fail: function("+
			"msg) {\n"+
			"			console.log(\"serverStatus error: \" + msg);\n"+
			"		}}));\n"+
			"};\n"+
			"\n"+
			"// @param {string} blobref root of the tree\n"+
			"// @param {Function} success callback with data.\n"+
			"// @param {?Function} opt_fail optional failure calback\n"+
			"cam.ServerConnection.prototype.getFileTree = function(blobref, success, opt_fail)"+
			" {\n"+
			"	// TODO(mpl): do it relatively to a discovered root?\n",
		"	var path = \"./tree/\" + blobref;\n"+
			"	this.sendXhr_(path, goog.bind(this.handleXhrResponseJson_, this, {success: succe"+
			"ss, fail: opt_fail}));\n"+
			"};\n"+
			"\n"+
			"\n"+
			"// @param {string} signer permanode must belong to signer.\n"+
			"// @param {string} attr searched attribute.\n"+
			"// @param {string} value value of the searched attribute.\n"+
			"// @param {Function} success.\n"+
			"// @param {Function=} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.permanodeOfSignerAttrValue = function(signer, attr"+
			", value, success, opt_fail) {\n"+
			"	var path = goog.uri.utils.appendPath(this.config_.searchRoot, 'camli/search/sign"+
			"erattrvalue');\n"+
			"	path = goog.uri.utils.appendParams(path,\n"+
			"		'signer', signer, 'attr', attr, 'value', value\n"+
			"	);\n"+
			"\n"+
			"	this.sendXhr_(\n"+
			"		path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this,\n"+
			"			{success: success, fail: opt_fail}\n"+
			"		)\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"\n"+
			"// @param {string|object} query If string, will be sent as 'expression', otherwis"+
			"e will be sent as 'constraint'.\n"+
			"// @param {?object} opts query parameters: describe, sort, limit, around, continu"+
			"ationToken.\n"+
			"cam.ServerConnection.prototype.buildQuery = function(callerQuery, opts) {\n"+
			"	var query = {\n"+
			"		// TODO(mpl): it'd be better to not ask for a sort when none is needed (less wo"+
			"rk for server),\n"+
			"		// e.g. for a plain BlobRefPrefix query.\n"+
			"		sort: \"-created\"\n"+
			"	};\n"+
			"\n"+
			"	if (goog.isString(callerQuery)) {\n"+
			"		query.expression = callerQuery;\n"+
			"	} else {\n"+
			"		query.constraint = callerQuery;\n"+
			"	}\n"+
			"\n"+
			"	if (!opts) {\n"+
			"		return query;\n"+
			"	}\n"+
			"	if (opts.sort) {\n",
		"		query.sort = opts.sort;\n"+
			"	}\n"+
			"	if (opts.describe) {\n"+
			"		query.describe = opts.describe;\n"+
			"	}\n"+
			"	if (opts.limit) {\n"+
			"		query.limit = opts.limit;\n"+
			"	}\n"+
			"	if (opts.around) {\n"+
			"		query.around = opts.around;\n"+
			"	} else if (opts.continuationToken) {\n"+
			"		query.continue = opts.continuationToken;\n"+
			"	}\n"+
			"\n"+
			"	return query;\n"+
			"}\n"+
			"\n"+
			"// @param {string|object} query If string, will be sent as 'expression', otherwis"+
			"e will be sent as 'constraint'.\n"+
			"// @param {?object} opts The query parameters: describe, sort, limit, around, con"+
			"tinuationToken.\n"+
			"cam.ServerConnection.prototype.search = function(query, opts, callback) {\n"+
			"	var path = goog.uri.utils.appendPath(this.config_.searchRoot, 'camli/search/quer"+
			"y');\n"+
			"	this.sendXhr_(path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this, {success: callback, fail: callback"+
			"}),\n"+
			"		\"POST\", JSON.stringify(this.buildQuery(query, opts)));\n"+
			"};\n"+
			"\n"+
			"// Where is the target accessed via? (paths it's at)\n"+
			"// @param {string} signer owner of permanode.\n"+
			"// @param {string} target blobref of permanode we want to find paths to\n"+
			"// @param {Function} success.\n"+
			"// @param {Function=} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.pathsOfSignerTarget = function(target, success, op"+
			"t_fail) {\n"+
			"	var path = goog.uri.utils.appendPath(\n"+
			"		this.config_.searchRoot, 'camli/search/signerpaths'\n"+
			"	);\n"+
			"	path = goog.uri.utils.appendParams(path, 'signer', this.config_.signing.publicKe"+
			"yBlobRef, 'target', target);\n"+
			"	this.sendXhr_(path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this, {success: success, fail: opt_fail}"+
			"));\n"+
			"};\n"+
			"\n"+
			"// @param {string} permanode Permanode blobref.\n"+
			"// @param {Function} success.\n"+
			"// @param {Function=} opt_fail Optional fail callback.\n",
		"cam.ServerConnection.prototype.permanodeClaims = function(permanode, success, opt"+
			"_fail) {\n"+
			"	var path = goog.uri.utils.appendPath(\n"+
			"		this.config_.searchRoot, 'camli/search/claims?permanode=' + permanode\n"+
			"	);\n"+
			"\n"+
			"	this.sendXhr_(\n"+
			"		path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this,\n"+
			"			{success: success, fail: opt_fail}\n"+
			"		)\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {Object} clearObj Unsigned object.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.sign_ = function(clearObj, success, opt_fail) {\n"+
			"	var sigConf = this.config_.signing;\n"+
			"	if (!sigConf || !sigConf.publicKeyBlobRef) {\n"+
			"		this.failOrLog_(opt_fail, \"Missing Camli.config.signing.publicKeyBlobRef\");\n"+
			"		return;\n"+
			"	}\n"+
			"	var authToken = this.config_.authToken;\n"+
			"	if (!authToken) {\n"+
			"		this.failOrLog_(opt_fail, \"Missing Camli.config.authToken\");\n"+
			"		return;\n"+
			"	}\n"+
			"	if (authToken != OMIT_AUTH_TOKEN) {\n"+
			"		var header = {\"Content-Type\": \"application/x-www-form-urlencoded\",\n"+
			"			\"Authorization\": \"Token \"+authToken};\n"+
			"	} else {\n"+
			"		var header = {\"Content-Type\": \"application/x-www-form-urlencoded\"};\n"+
			"	}\n"+
			"\n"+
			"	clearObj.camliSigner = sigConf.publicKeyBlobRef;\n"+
			"	var camVersion = clearObj.camliVersion;\n"+
			"	if (camVersion) {\n"+
			"		 delete clearObj.camliVersion;\n"+
			"	}\n"+
			"	var clearText = JSON.stringify(clearObj, null, \"	\");\n"+
			"	if (camVersion) {\n"+
			"		 clearText = \"{\\\"camliVersion\\\":\" + camVersion + \",\\n\" + clearText.substr(\"{\\n\""+
			".length);\n"+
			"	}\n"+
			"	this.sendXhr_(\n"+
			"		sigConf.signHandler,\n"+
			"		goog.bind(this.handleXhrResponseText_, this,\n"+
			"			{success: success, fail: opt_fail}),\n"+
			"		\"POST\",\n",
		"		\"json=\" + encodeURIComponent(clearText),\n"+
			"		header\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {Object} signed Signed JSON blob (string) to verify.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.verify_ = function(signed, success, opt_fail) {\n"+
			"	var sigConf = this.config_.signing;\n"+
			"	if (!sigConf || !sigConf.publicKeyBlobRef) {\n"+
			"		if (opt_fail) {\n"+
			"			opt_fail(\"Missing Camli.config.signing.publicKeyBlobRef\");\n"+
			"		} else {\n"+
			"			console.log(\"Missing Camli.config.signing.publicKeyBlobRef\");\n"+
			"		}\n"+
			"		return;\n"+
			"	}\n"+
			"	var authToken = this.config_.authToken;\n"+
			"	if (!authToken) {\n"+
			"		this.failOrLog_(opt_fail, \"Missing Camli.config.authToken\");\n"+
			"		return;\n"+
			"	}\n"+
			"	if (authToken != OMIT_AUTH_TOKEN) {\n"+
			"		var header = {\"Content-Type\": \"application/x-www-form-urlencoded\",\n"+
			"			\"Authorization\": \"Token \"+authToken};\n"+
			"	} else {\n"+
			"		var header = {\"Content-Type\": \"application/x-www-form-urlencoded\"};\n"+
			"	}\n"+
			"	this.sendXhr_(\n"+
			"		sigConf.verifyHandler,\n"+
			"		goog.bind(this.handleXhrResponseText_, this,\n"+
			"			{success: success, fail: opt_fail}),\n"+
			"		\"POST\",\n"+
			"		\"sjson=\" + encodeURIComponent(signed),\n"+
			"		header\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {goog.events.Event} e Event that triggered this\n"+
			"cam.ServerConnection.prototype.handleXhrResponseText_ = function(callbacks, e) {\n"+
			"	var fail = callbacks.fail;\n"+
			"	var xhr = e.target;\n"+
			"	var error = !xhr.isSuccess();\n"+
			"	var result = null;\n"+
			"	if (!error) {\n"+
			"		result = xhr.getResponseText();\n"+
			"		error = !result;\n"+
			"	}\n"+
			"	if (error) {\n",
		"		if (fail) {\n"+
			"			fail(xhr.getLastError());\n"+
			"		} else {\n"+
			"			// TODO(bslatkin): Add a default failure event handler to this class.\n"+
			"			console.log('Failed XHR (text) in ServerConnection: ' + xhr.getLastError());\n"+
			"		}\n"+
			"		return;\n"+
			"	}\n"+
			"	callbacks.success(result);\n"+
			"};\n"+
			"\n"+
			"// @param {string} s String to upload.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.uploadString_ = function(s, success, opt_fail) {\n"+
			"	var authToken = this.config_.authToken;\n"+
			"	if (!authToken) {\n"+
			"		this.failOrLog_(opt_fail, \"Missing Camli.config.authToken\");\n"+
			"		return;\n"+
			"	}\n"+
			"	if (authToken != OMIT_AUTH_TOKEN) {\n"+
			"		var header = {\"Authorization\": \"Token \"+authToken};\n"+
			"	}\n"+
			"	var blobref = cam.blob.refFromString(s);\n"+
			"	var bb = new Blob([s]);\n"+
			"	var fd = new FormData();\n"+
			"	// Regarding https://perkeep.org/issue/660 , it seems like doing\n"+
			"	// fd.append(blobref, s);\n"+
			"	// instead does not suffer for the \"first upload\" problem. However,\n"+
			"	// we get a mismatched blobRef if we do that, which I suppose is a\n"+
			"	// JSON serialization problem that we could avoid by adopting a convention?\n"+
			"	fd.append(blobref, bb);\n"+
			"\n"+
			"	// TODO: hack, hard-coding the upload URL here.\n"+
			"	// Change the spec now that App Engine permits 32 MB requests\n"+
			"	// and permit a PUT request on the sha1?	Or at least let us\n"+
			"	// specify the well-known upload URL?	In cases like this, uploading\n"+
			"	// a new permanode, it's silly to even stat.\n"+
			"	this.sendXhr_(\n"+
			"		this.config_.blobRoot + \"camli/upload\",\n"+
			"		goog.bind(this.handleUploadString_, this,\n"+
			"			blobref,\n"+
			"			{success: success, fail: opt_fail}\n"+
			"		),\n"+
			"		\"POST\",\n"+
			"		fd,\n"+
			"		header\n"+
			"	);\n"+
			"\n"+
			"};\n",
		"\n"+
			"// @param {string} blobref Uploaded blobRef.\n"+
			"// @param {goog.events.Event} e Event that triggered this\n"+
			"cam.ServerConnection.prototype.handleUploadString_ = function(blobref, callbacks,"+
			" e) {\n"+
			"	this.handleXhrResponseText_({\n"+
			"		success: function(resj) {\n"+
			"			if (!resj) {\n"+
			"				alert(\"upload failed; no response\");\n"+
			"				return;\n"+
			"			}\n"+
			"			var resObj = JSON.parse(resj);\n"+
			"			if (!resObj.received || !resObj.received[0] || !resObj.received[0].blobRef) {\n"+
			"				alert(\"upload permanode fail, expected blobRef not in response\");\n"+
			"				return;\n"+
			"			}\n"+
			"			if (callbacks.success) {\n"+
			"				callbacks.success(blobref);\n"+
			"			}\n"+
			"		},\n"+
			"		fail: callbacks.fail},\n"+
			"		e\n"+
			"	)\n"+
			"};\n"+
			"\n"+
			"cam.ServerConnection.prototype.failOrLog_ = function(fail, msg) {\n"+
			"	if (fail) {\n"+
			"		fail(msg);\n"+
			"	} else {\n"+
			"		console.log(msg);\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.createPermanode = function(success, opt_fail) {\n"+
			"	var json = {\n"+
			"		\"camliVersion\": 1,\n"+
			"		\"camliType\": \"permanode\",\n"+
			"		\"random\": \"\"+Math.random()\n"+
			"	};\n"+
			"	this.sign_(json,\n"+
			"		goog.bind(function(signed) {\n"+
			"			this.uploadString_(signed, success, opt_fail)\n"+
			"		}, this),\n"+
			"		goog.bind(function(msg) {\n"+
			"			this.failOrLog_(opt_fail, \"create permanode: signing failed: \" + msg);\n"+
			"		}, this)\n"+
			"	);\n"+
			"};\n",
		"\n"+
			"// @param {string} permanode Permanode to change.\n"+
			"// @param {string} claimType What kind of claim: \"add-attribute\", \"set-attribute\""+
			"...\n"+
			"// @param {string} attribute What attribute the claim applies to.\n"+
			"// @param {string} value Attribute value.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.changeAttribute_ = function(permanode, claimType, "+
			"attribute, value, success, opt_fail) {\n"+
			"	var json = {\n"+
			"		\"camliVersion\": 1,\n"+
			"		\"camliType\": \"claim\",\n"+
			"		\"permaNode\": permanode,\n"+
			"		\"claimType\": claimType,\n"+
			"		// TODO(mpl): to (im)port.\n"+
			"		\"claimDate\": dateToRfc3339String(new Date()),\n"+
			"		\"attribute\": attribute,\n"+
			"		\"value\": value\n"+
			"	};\n"+
			"	this.sign_(json,\n"+
			"		goog.bind(function(signed) {\n"+
			"			this.uploadString_(signed, success, opt_fail)\n"+
			"		}, this),\n"+
			"		goog.bind(function(msg) {\n"+
			"			this.failOrLog_(opt_fail, \"change attribute: signing failed: \" + msg);\n"+
			"		}, this)\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {string} permanode Permanode to delete.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.newDeleteClaim = function(permanode, success, opt_"+
			"fail) {\n"+
			"	var json = {\n"+
			"		\"camliVersion\": 1,\n"+
			"		\"camliType\": \"claim\",\n"+
			"		\"target\": permanode,\n"+
			"		\"claimType\": \"delete\",\n"+
			"		\"claimDate\": dateToRfc3339String(new Date())\n"+
			"	};\n"+
			"	this.sign_(json,\n"+
			"		goog.bind(function(signed) {\n"+
			"			this.uploadString_(signed, success, opt_fail)\n"+
			"		}, this),\n"+
			"		goog.bind(function(msg) {\n"+
			"			this.failOrLog_(opt_fail, \"delete attribute: signing failed: \" + msg);\n"+
			"		}, this)\n"+
			"	);\n",
		"};\n"+
			"\n"+
			"// @param {string} permanode Permanode blobref.\n"+
			"// @param {string} attribute Name of the attribute to set.\n"+
			"// @param {string} value Value to set the attribute to.\n"+
			"// @param {function(string)} success Success callback, called with blobref of upl"+
			"oaded file.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.newSetAttributeClaim = function(permanode, attribu"+
			"te, value, success, opt_fail) {\n"+
			"	this.changeAttribute_(permanode, \"set-attribute\", attribute, value,\n"+
			"		success, opt_fail\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"\n"+
			"// @param {string} permanode Permanode blobref.\n"+
			"// @param {string} attribute Name of the attribute to add.\n"+
			"// @param {string} value Value of the added attribute.\n"+
			"// @param {function(string)} success Success callback, called with blobref of upl"+
			"oaded file.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.newAddAttributeClaim = function(permanode, attribu"+
			"te, value, success, opt_fail) {\n"+
			"	this.changeAttribute_(permanode, \"add-attribute\", attribute, value,\n"+
			"		success, opt_fail\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {string} permanode Permanode blobref.\n"+
			"// @param {string} attribute Name of the attribute to delete.\n"+
			"// @param {string} value Value of the attribute to delete.\n"+
			"// @param {function(string)} success Success callback, called with blobref of upl"+
			"oaded file.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.newDelAttributeClaim = function(permanode, attribu"+
			"te, value, success, opt_fail) {\n"+
			"	this.changeAttribute_(permanode, \"del-attribute\", attribute, value,\n"+
			"		success, opt_fail\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {File} file File to be uploaded.\n"+
			"// @param {function(string)} success Success callback, called with blobref of\n"+
			"// uploaded file.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"// @param {?Function} opt_onContentsRef Optional callback to set contents during "+
			"upload.\n"+
			"cam.ServerConnection.prototype.uploadFile = function(file, success, opt_fail, opt"+
			"_onContentsRef) {\n",
		"	var msg = {};\n"+
			"	msg.blob = file;\n"+
			"	msg.doLegacySHA1 = this.config_.hasLegacySHA1Index;\n"+
			"	this.getWorker_().sendMessage('ref', msg, function(wholeRefs) {\n"+
			"		if (opt_onContentsRef) {\n"+
			"			opt_onContentsRef(wholeRefs);\n"+
			"		}\n"+
			"		this.camliUploadFileHelper_(file, wholeRefs, success, opt_fail);\n"+
			"	}.bind(this));\n"+
			"};\n"+
			"\n"+
			"// camliUploadFileHelper uploads the provided file with contents blobref contents"+
			"BlobRef\n"+
			"// and returns a blobref of a file blob.	It does not create any permanodes.\n"+
			"// Most callers will use camliUploadFile instead of this helper.\n"+
			"//\n"+
			"// camliUploadFileHelper only uploads chunks of the file if they don't already ex"+
			"ist\n"+
			"// on the server. It starts by assuming the file might already exist on the serve"+
			"r\n"+
			"// and, if so, uses an existing (but re-verified) file schema ref instead.\n"+
			"// @param {File} file File to be uploaded.\n"+
			"// @param {List} wholeRefs Blob ref of file contents as computed locally.\n"+
			"// Second, optional, element of the list is legacy SHA-1 blob Ref.\n"+
			"// @param {function(string)} success function(fileBlobRef) of the\n"+
			"// server-validated or just-uploaded file schema blob.\n"+
			"// @param {?Function} opt_fail Optional fail callback.\n"+
			"cam.ServerConnection.prototype.camliUploadFileHelper_ = function(file, wholeRefs,"+
			" success, opt_fail) {\n"+
			"	if (!this.config_.uploadHelper) {\n"+
			"		this.failOrLog_(opt_fail, \"no uploadHelper available\");\n"+
			"		return;\n"+
			"	}\n"+
			"	var authToken = this.config_.authToken;\n"+
			"	if (!authToken) {\n"+
			"		this.failOrLog_(opt_fail, \"Missing Camli.config.authToken\");\n"+
			"		return;\n"+
			"	}\n"+
			"	if (authToken != OMIT_AUTH_TOKEN) {\n"+
			"		var header = {\"Authorization\": \"Token \"+authToken};\n"+
			"	}\n"+
			"	var doUpload = goog.bind(function() {\n"+
			"		var fd = new FormData();\n"+
			"		fd.append(\"modtime\", dateToRfc3339String(new Date(file.lastModified)));\n"+
			"		fd.append(\"ui-upload-file-helper-form\", file);\n"+
			"		this.sendXhr_(\n"+
			"			this.config_.uploadHelper,\n"+
			"			goog.bind(this.handleUpload_, this,\n"+
			"				file, wholeRefs[0], {success: success, fail: opt_fail}\n"+
			"			),\n",
		"			\"POST\",\n"+
			"			fd,\n"+
			"			header\n"+
			"		);\n"+
			"	}, this);\n"+
			"\n"+
			"	this.findExistingFileSchemas_(\n"+
			"		wholeRefs,\n"+
			"		goog.bind(this.dupCheck_, this,\n"+
			"			doUpload, success\n"+
			"		),\n"+
			"		opt_fail\n"+
			"	)\n"+
			"}\n"+
			"\n"+
			"// @param {File} file File to be uploaded.\n"+
			"// @param {string} contentsBlobRef Blob ref of file as sha1'd locally.\n"+
			"// @param {goog.events.Event} e Event that triggered this\n"+
			"cam.ServerConnection.prototype.handleUpload_ = function(file, contentsBlobRef, ca"+
			"llbacks, e) {\n"+
			"	this.handleXhrResponseText_({\n"+
			"		success: goog.bind(function(res) {\n"+
			"			var resObj = JSON.parse(res);\n"+
			"			if (resObj.got && resObj.got.length == 1 && resObj.got[0].fileref) {\n"+
			"				var fileblob = resObj.got[0].fileref;\n"+
			"				console.log(\"uploaded \" + contentsBlobRef + \" => file blob \" + fileblob);\n"+
			"				callbacks.success(fileblob);\n"+
			"			} else {\n"+
			"				this.failOrLog_(callbacks.fail, \"failed to upload \" + file.name + \": \" + cont"+
			"entsBlobRef + \": \" + JSON.stringify(res, null, 2));\n"+
			"			}\n"+
			"		}, this),\n"+
			"		fail: callbacks.fail},\n"+
			"		e\n"+
			"	)\n"+
			"};\n"+
			"\n"+
			"// @param {List} wholeDigestRefs file contents digests (current hash in use, then"+
			" optionally legacy SHA-1 hash).\n"+
			"// @param {Function} success callback with data.\n"+
			"// @param {?Function} opt_fail optional failure calback\n"+
			"cam.ServerConnection.prototype.findExistingFileSchemas_ = function(wholeDigestRef"+
			"s, success, opt_fail) {\n"+
			"	var path = goog.uri.utils.appendPath(this.config_.searchRoot, 'camli/search/file"+
			"s');\n"+
			"	for (var i=0; i<wholeDigestRefs.length; i++) {\n"+
			"		path = goog.uri.utils.appendParam(path, 'wholedigest', wholeDigestRefs[i]);\n"+
			"		console.log(path);\n"+
			"	}\n"+
			"\n",
		"	this.sendXhr_(\n"+
			"		path,\n"+
			"		goog.bind(this.handleXhrResponseJson_, this,\n"+
			"			{success: success, fail: opt_fail}\n"+
			"		)\n"+
			"	);\n"+
			"};\n"+
			"\n"+
			"// @param {Function} doUpload fun that takes care of uploading.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {Object} res result from the wholedigest search, that maps a wholeRef t"+
			"o its file blobRefs.\n"+
			"cam.ServerConnection.prototype.dupCheck_ = function(doUpload, success, res) {\n"+
			"	var checkNext = goog.bind(function(filesByWholeRef, wholeRefs, files) {\n"+
			"		if (!files || files.length == 0) {\n"+
			"			var nextWholeRefs = wholeRefs.slice(1);\n"+
			"			if (nextWholeRefs.length == 0) {\n"+
			"				doUpload();\n"+
			"				return;\n"+
			"			}\n"+
			"			var nextWholeRef = nextWholeRefs[0];\n"+
			"			var nextFiles = filesByWholeRef[nextWholeRef];\n"+
			"			checkNext(filesByWholeRef, nextWholeRefs, nextFiles);\n"+
			"			return;\n"+
			"		}\n"+
			"\n"+
			"		var currentWholeRef = wholeRefs[0];\n"+
			"		var currentFile = files[0];\n"+
			"\n"+
			"		this.sendXhr_(\n"+
			"			this.config_.downloadHelper + currentFile + \"/?verifycontents=\" + currentWhole"+
			"Ref,\n"+
			"			goog.bind(this.handleVerifycontents_, this,\n"+
			"				currentWholeRef, filesByWholeRef, wholeRefs, files, checkNext, success),\n"+
			"			\"HEAD\"\n"+
			"		);\n"+
			"	}, this);\n"+
			"\n"+
			"	var filesByWholeRef = res.files;\n"+
			"	if (filesByWholeRef.length == 0) {\n"+
			"		doUpload();\n"+
			"		return;\n"+
			"	}\n"+
			"	var wholeRefs = Object.keys(filesByWholeRef);\n"+
			"	var files = filesByWholeRef[wholeRefs[0]];\n"+
			"	checkNext(filesByWholeRef, wholeRefs, files);\n"+
			"}\n"+
			"\n"+
			"// @param {string} contentsBlobRef Blob ref of file as sha224'd locally.\n"+
			"// @param {Object} filesByWholeRef maps a wholeRef to its file blobRefs.\n",
		"// @param {Array.<string>} wholeRefs wholeRefs to check.\n"+
			"// @param {Array.<string>} files files to check.\n"+
			"// @param {Function} checkNext fun, recursive call.\n"+
			"// @param {Function} success Success callback.\n"+
			"// @param {goog.events.Event} e Event that triggered this\n"+
			"cam.ServerConnection.prototype.handleVerifycontents_ = function(\n"+
			"	contentsBlobRef, filesByWholeRef, wholeRefs, files, checkNext, success, e) {\n"+
			"	var xhr = e.target;\n"+
			"	var error = !(xhr.isComplete() && xhr.getStatus() == 200);\n"+
			"	var checkFile = files.shift();\n"+
			"\n"+
			"	if (error) {\n"+
			"		console.log(\"integrity check failed on \" + checkFile);\n"+
			"		checkNext(filesByWholeRef, wholeRefs, files);\n"+
			"		return;\n"+
			"	}\n"+
			"	if (xhr.getResponseHeader(\"X-Camli-Contents\") == contentsBlobRef) {\n"+
			"		console.log(\"integrity check passed on \" + checkFile + \"; using it.\");\n"+
			"		success(checkFile);\n"+
			"	} else {\n"+
			"		checkNext(filesByWholeRef, wholeRefs, files);\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"// Format |dateVal| as specified by RFC 3339.\n"+
			"function dateToRfc3339String(dateVal) {\n"+
			"	// Return a string containing |num| zero-padded to |length| digits.\n"+
			"	var pad = function(num, length) {\n"+
			"		var numStr = \"\" + num;\n"+
			"		while (numStr.length < length) {\n"+
			"			numStr = \"0\" + numStr;\n"+
			"		}\n"+
			"		return numStr;\n"+
			"	};\n"+
			"\n"+
			"	return goog.string.subs(\"%s-%s-%sT%s:%s:%sZ\",\n"+
			"		dateVal.getUTCFullYear(), pad(dateVal.getUTCMonth() + 1, 2), pad(dateVal.getUTC"+
			"Date(), 2),\n"+
			"		pad(dateVal.getUTCHours(), 2), pad(dateVal.getUTCMinutes(), 2), pad(dateVal.get"+
			"UTCSeconds(), 2));\n"+
			"};\n"+
			"")))
}
