// THIS FILE IS AUTO-GENERATED FROM worker_message_router.js
// DO NOT EDIT.
// +build with_embed

package ui

import "time"

import "perkeep.org/pkg/fileembed"

func init() {
	Files.Add("worker_message_router.js", 3093, time.Unix(0, 1605118498722856000), fileembed.String(fileembed.JoinStrings("/*\n"+
		"Copyright 2014 The Perkeep Authors\n"+
		"\n"+
		"Licensed under the Apache License, Version 2.0 (the \"License\");\n"+
		"you may not use this file except in compliance with the License.\n"+
		"You may obtain a copy of the License at\n"+
		"\n"+
		"	http://www.apache.org/licenses/LICENSE-2.0\n"+
		"\n"+
		"Unless required by applicable law or agreed to in writing, software\n"+
		"distributed under the License is distributed on an \"AS IS\" BASIS,\n"+
		"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n"+
		"See the License for the specific language governing permissions and\n"+
		"limitations under the License.\n"+
		"*/\n"+
		"\n"+
		"goog.provide('cam.WorkerMessageRouter');\n"+
		"\n"+
		"goog.require('goog.string');\n"+
		"\n"+
		"// Convenience for sending request/response style messages to and from workers.\n"+
		"// @param {!Worker} worker The DOM worker to wrap.\n"+
		"// @constructor\n"+
		"cam.WorkerMessageRouter = function(worker) {\n"+
		"	this.worker_ = worker;\n"+
		"	this.nextMessageId_ = 1;\n"+
		"\n"+
		"	// name->handler - See registerHandler()\n"+
		"	// @type Object.<string, function(*, function(*))>\n"+
		"	this.handlers_ = {};\n"+
		"\n"+
		"	// messageid->callback - See sendMessage()\n"+
		"	// @type Object.<number, function(*)>\n"+
		"	this.pendingMessages_ = {};\n"+
		"\n"+
		"	this.worker_.addEventListener('message', this.handleMessage_.bind(this));\n"+
		"};\n"+
		"\n"+
		"// Send a message over the worker, optionally expecting a response.\n"+
		"// @param {!string} name The name of the message to send.\n"+
		"// @param {!*} msg The message content\n"+
		"// @param {?function(*)} opt_callback The function to receive the response.\n"+
		"cam.WorkerMessageRouter.prototype.sendMessage = function(name, msg, opt_callback)"+
		" {\n"+
		"	var messageId = 0;\n"+
		"	if (opt_callback) {\n"+
		"		messageId = this.nextMessageId_++;\n"+
		"		this.pendingMessages_[messageId] = opt_callback;\n"+
		"	}\n"+
		"	this.worker_.postMessage({\n",
		"		messageId: messageId,\n"+
			"		name: name,\n"+
			"		message: msg\n"+
			"	});\n"+
			"};\n"+
			"\n"+
			"// Registers a function to handle a particular named message type.\n"+
			"// @param {!string} name The name of the message type to handle.\n"+
			"// @param {!function(*, function(*))} handler The function to call to return the "+
			"reply to the client.\n"+
			"cam.WorkerMessageRouter.prototype.registerHandler = function(name, handler) {\n"+
			"	this.handlers_[name] = handler;\n"+
			"};\n"+
			"\n"+
			"cam.WorkerMessageRouter.prototype.handleMessage_ = function(e) {\n"+
			"	if (!goog.isObject(e.data) || !goog.isDef(e.data.messageId)) {\n"+
			"		return;\n"+
			"	}\n"+
			"\n"+
			"	if (goog.isDef(e.data.name)) {\n"+
			"		this.handleRequest_(e.data);\n"+
			"	} else {\n"+
			"		this.handleReply_(e.data);\n"+
			"	}\n"+
			"};\n"+
			"\n"+
			"cam.WorkerMessageRouter.prototype.handleRequest_ = function(request) {\n"+
			"	var handler = this.handlers_[request.name];\n"+
			"	if (!handler) {\n"+
			"		throw new Error(goog.string.subs('No registered handler with name: %s', request"+
			".name));\n"+
			"	}\n"+
			"\n"+
			"	var sendReply = function(reply) {\n"+
			"		if (!request.messageId) {\n"+
			"			return;\n"+
			"		}\n"+
			"		this.worker_.postMessage({\n"+
			"			messageId: request.messageId,\n"+
			"			message: reply\n"+
			"		});\n"+
			"	}.bind(this);\n"+
			"\n"+
			"	handler(request.message, sendReply);\n"+
			"};\n"+
			"\n"+
			"cam.WorkerMessageRouter.prototype.handleReply_ = function(reply) {\n"+
			"	var callback = this.pendingMessages_[reply.messageId];\n"+
			"	if (!callback) {\n"+
			"		throw new Error('Could not find callback for pending message: %s', reply.messag",
		"eId);\n"+
			"	}\n"+
			"	delete this.pendingMessages_[reply.messageId];\n"+
			"	callback(reply.message);\n"+
			"};\n"+
			"")))
}
